class xRestartChar
{
};

class clsMonsterDescSource
{
public:
	string FileName;
	string Content;
};

class clsBonus
{
public:
	int Pointer;
	int Value;
	int Type;
	string Text;
};

template <class T> class ListA
{
public:
	ListA<T>* NextElem;
	T val;

	ListA()
	{
		NextElem = NULL;
	}

	~ListA()
	{
		if (NextElem)
		{
			delete NextElem;
		}
	}
};

template <class T> class List : public T
{
public:
	List<T>* NextElem;

	List()
	{
		NextElem = NULL;
	}

	~List()
	{
		if (NextElem)
		{
			delete NextElem;
		}
	}
};

template <class T> class p
{
public:
	T* ptr;

	p()
	{
		ptr = NULL;
	}

	~p()
	{
		freep();
	}

	void freep()
	{
		if (ptr)
		{
			freel(ptr);
			ptr = NULL;
		}
	}

	T* operator =(T* ptr2)
	{
		return(ptr = ptr2);
	}

	operator T*() const
	{
		return(ptr);
	}
};


struct CharTemplate
{
	char ident[4];
	int TemplateType;
	int AttributeType;
	int MinLevel;
	int MaxLevel;
	int* Class;
	int ClassCount;
	int* AttributePreset;
	int Monster;
	int MonsterName;
	int MonsterNameHD;
	int MonsterNameTemplate;
	int Mixed;
	int Treasure;
	int NPCClass;
	int Race;

	int TreasureMin;
	int TreasureMax;

	int DrawType;
	int CalcType;
	int AllowEpic;
	int LastMonster;

	int Life;

	struct seedstru
	{
		unsigned long seed[517];
	};
	struct restru
	{
		unsigned long retemp[REPRODUCE_SAVE];
		unsigned long repos;
	};
	
	union
	{
		seedstru seed;
		restru re;
	};
};

struct clsSourceFake
{
	basestring Name;
};

struct clsMonsterSource
{
	basestring Name;
	basestring MonsterDesc;
	int CR;
	int Type;
	int Size;
	int Epic;
	int HD;
	int HDType;
	int TPBonus;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int Attr[6];
	int AC;
	int HDMin;
	int HDMax;
	int HDInc;
	int HDInc2;
	int Init;
	int Speed;
	int OrgMin;
	int OrgMax;
	int Mixed;
	int Treasure;
	int AttackBonus[6];
	int AttackNumber[6];
	int AttackRed[6];
	int DamageA[6];
	int DamageB[6];
	int DamageC[6];
	basestring AttackType[6];
	int AlternateAttack[6];
	int AttackCount;
	int Feats[6];
	int FeatCount;
	int Skills[7];
	int SkillLevels[7];
	int SkillCount;
	char* SpellChar;
	int ClericSpells;
	char* Familiar;
};

struct clsPowerSource
{
	basestring Name;
	int Psion;
	int PsychicW;
	int Attribute;
};

struct clsEffectSource
{
	basestring Name;
	int Weapon;
	int Armor;
	int Shield;
	int Helmet;
	int Gloves;
	int Boots;
	int Belt;
	int Cloak;
	int Ring;
	int Amulet;
	int Fight;
	int Magic;
	int Shadow;
	int Divine;
	int Multi;
	int Cost;
	int Cost2;
	int Quality;
	char* Script;
	p<int> SkillCode;
	char* Variable;
	int Ranged;
};

struct clsSpellSource
{
	basestring Name;
	int Probability;
	int* ClassLevels;
	int DomainCount;
	int DomainLevel;
	int Domains[2];
	int School;
};

struct clsEquipSource
{
	basestring Name;
	int EquipType;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int AttackType;
	int* Probability;
	int* RaceProbability;
	int StdProb;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int SpecialType;
	int MinLevel;
	int Rare;
	int Price;
	char* Script;
	int ForbidEffects;
	int Amount;
};

struct clsEquip
{
	int ID;
	int EquipType;
	int Enhencement;
	int Effect[MAX_EFFECTS];
	int EffectVariable[MAX_EFFECTS];
	string EffectDesc[MAX_EFFECTS];
	int EffectCount;
	int EffectCountA;
	int ForceEffects;
	int Damage1;
	int Damage2;
	int Damage3;
	int Size;
	int Type;
	int Critical;
	int CriticalMultiplier;
	int CriticalMultiplier2;
	int CriticalBonus;
	int AttackType;
	int Armor;
	int MaxDex;
	int Malus;
	int SpellFailure;
	int Metallic;
	int AttackBonus;
	int AttackBonusA;
	int TwoWeapon;
	int TwoWeaponSecond;
	int TwoHand;
	int MaxStr;
	int Primary;
	int Secondary;
	int Value;
	int BaseValue;
	int Adamantine;
	int Mithril;
	int Mercury;
	int Masterwork;
	int ShieldUsed;
	int IncludeInTreasure;
	int MaxEnh;
	string EquipDesc;
	int Specific;
};

struct clsRaceSource
{
	basestring Name;
	int Probability;
	int Size;
	int PreferedAttackType;
	char* Script;
	int RaceModBin[6];
	int Range;
	int SubRaceBin;
	int HGMod;
	char* RaceFeats;
};

struct clsChar
{
	CharTemplate* CreationTemplate;
	List<clsBonus>* Boni;

	int CRPosCount;
	int CRPosHD[32];
	int CRPosTemplate[32];
	int CRPosCR[32];

	int Profiled;
	int ProfileStrength;
	int Profile;

	int Mixed;
	int MixedHG;

	int HasTemplate;

	int Rel;
	int NPCClass;

	__int64 CreationTime;
	__int64 MixedTime;
	int DisplayTime;

	int HG;
	
	int Attributes[6];
	int Mods[6];

	int ClassCount;
	int Classes[MAX_CLASSES];
	int DummyClass[MAX_CLASSES];
	int DummyClassClericSpells[MAX_CLASSES];
	int Level;
	int Levels[MAX_CLASSES];
	int LevelsClassic[MAX_CLASSES];
	int CasterLevel[MAX_CLASSES];

	int Life;
	int LifeBonus;
	
	int GA;
	int GASize;
	int GAMelee;
	int GAShot;
	int GAMeleeAttr;
	int GAShotAttr;
	int GAMeleeRest;
	int GAShotRest;
	int GAEpic;
	
	int RWEpic;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int RWRefBase;
	int RWWilBase;
	int RWZaehBase;
	int RWRefAttr;
	int RWWilAttr;
	int RWZaehAttr;
	int RWRefMage;
	int RWWilMage;
	int RWZaehMage;
	int RWRefRest;
	int RWWilRest;
	int RWZaehRest;
	
	int FeatCount;
	int Feats[MAX_FEATS];
	int FeatDependancy[MAX_FEATS];
	int FeatDone[MAX_FEATS];
	int FeatTypeRequired[FEAT_TYPE_COUNT];
	int WeaponArmorShieldFeats;
	int InbornLeft;
	int BonusFeatCount;

	int AttackType[2];
	int AttackTypeCount;
	int Attacks;
	int Attacks2;
	int BonusAttacks;
	int AttacksOpportunity;
	int MonkAttacks;
	
	int EquipCount;
	clsEquip Equipment[MAX_EQUIP];
	int EquipTreasureCount;
	int EquipTreasureStart;
	int RingMax;
	int dart;
	
	int Skills[MAX_SKILLS];
	int SkillRank[MAX_SKILLS];
	int SkillRank2[MAX_SKILLS];
	int SkillBonus[MAX_SKILLS];
	int SkillAttr[MAX_SKILLS];
	int SkillMalus[MAX_SKILLS];
	int SkillTotal[MAX_SKILLS];
	int SkillCount;
	int SkillCountReal;
	int SkillRequired[MAX_SKILLS];
	int BonusSkillPointCount;

	int Race;
	int SubRace;

	int SpellsKnownCount[MAX_CLASSES][10];
	int SpellList[MAX_CLASSES][10][10];
	int SpellsPerDayCount[MAX_CLASSES][10];
	int SpellListCount[MAX_CLASSES][10];
	int BonusSpells;
	int BonusSpellLevelMin;
	int BonusSpellLevelMax;
	int HighestSpell;
	int SpellFailure;
	int TargetClass;

	int Domains[MAX_DOMAINS];
	int DomainCount;
	int DomainSpells[10];
	int DomainSpellCount;

	int Specialised;
	int School;
	int SchoolForbidden[MAX_SCHOOLS];

	int SchoolDC[MAX_SCHOOLS];
	int ArcaneDC;
	int DivineDC;
	int GeneralDC;

	char CharText[BUFFER_LEN];
	char CharTextPrimary[BUFFER_LEN];
	char CharTextSecondary[BUFFER_LEN];
	char CharTextTwo[BUFFER_LEN];

	int AC;
	int ACArmor;
	int ACShield;
	int ACDex;
	int ACSize;
	int ACRest;
	int MaxDex;
	int ArmorMalus;
	
	float Range;
	
	int MR;
	int MRBonus;
	int againstMR;
	
	int SpecialAbbilities;
	int Lores;
	int Arcanas;
	int HierophantAbilities;

	int Initiative;
	int InitiativeRest;
	int InitiativeDex;
	
	int AttackMod;
	int DmgMod;

	int Money;
	int MoneyRest;
	int Treasure;
	int TreasureLeft;
	int TreasureSellValue;

	int UnarmedDamage1;
	int UnarmedDamage2;
	
	int PowerPoints;
	int MainDisciple;
	int DiscipleDC[6];
	int PsionicDC;
	int CrystalCount;
	int CombatModes;
	
	int Monster;
	int MonsterName;
	int MonsterType;
	int MAttackBonus[6];
	int MAttackNumber[6];
	int MAttackRed[6];
	int MDamageA[6];
	int MDamageB[6];
	int MDamageC[6];
	int MAlternateAttack[6];
	int MAttackCount;
	int MSize;
	int MonsterTWType;
	int MonsterSize;
	string MAttackType[6];

	int SneakDmg;
	int Evasion;
	int Smite;
	int Dex2AC;
	int UncannyDodge;
	int LowLightVision;
	int DarkVision;
	int ShareSpells;
	int EmpathicLink;
	int SpeakWithMaster;
	int Concealment;
	int LayOnHands;
	int SacretDefense;
	int PoisonUse;
	int SurpremeCleave;
	int TouchReach;

	int Familiar;
	clsChar* pFamiliar;

	int AnimalCompanion;
	int AnimalCount;
	clsChar* pAnimalCompanion;

	int Mount;
	clsChar* pMount;

	int Servant;
	clsChar* pServant;

	clsChar()
	{
		pFamiliar = NULL;
		pAnimalCompanion = NULL;
		pMount = NULL;
		pServant = NULL;
		Boni = NULL;
	}

	~clsChar()
	{
		if (pFamiliar)
		{
			delete pFamiliar;
		}
		if (pAnimalCompanion)
		{
			delete[] pAnimalCompanion;
		}
		if (pMount)
		{
			delete pMount;
		}
		if (pServant)
		{
			delete pServant;
		}
		if (Boni)
		{
			delete Boni;
		}
	}
};

struct clsCharSource
{
	int Count;
	basestring Name;
	int TW;
	int AttributePriority[6];
	int Probability;
	int GA;
	int RWRef;
	int RWWil;
	int RWZaeh;
	int PreferedAttack;
	int ForceAttack;
	int Skills;
	int Prestige;
	int MaxLevel;
	int MaxLevelA;
	char* Script;
	char* ClassFeats;
	int SpellType;
	int SpellType2;
	int IncreaseSpellType;
	int SpontanCast;
	int SpontanCast2;
	int Domains;
	int Specialize;
	int PowerType;
	p<int> ReqCode;
	p<int> SkillCode;
	p<int> FeatCode;
	basestring BonusFeatType;
	basestring BonusFeats;
	int EpicFeats;
	int SpellFailure;
	int UseEffects;
	int AttachClassNum;
	int NoEq;
	int PsionicDisciple;
	int PsiCrystal;
	int ForceWeaponType;
	int NaturalEnhence;
	int NPC;
	int SpellAttr;
	int BonusClassSkills;
	int ForceWeaponNum;
	int NoMetal;
};

struct clsFeatSource
{
	basestring Name;
	int* Probability;
	int MultipleTimes;
	int Epic;
	p<int> ReqCode;
	int CopyDepFrom;
	p<int> SkillCode;
	int DepType;
	char* Script;
	int AttackDep;
	int FeatType;
	basestring Text;
	int Inborn;
	int* Rel;
	int RelCount;
	int Standard;
	int Exclusive;
};

struct clsSkillSource
{
	basestring Name;
	int* Prob;
	int Attr;
	p<int> SynCode;
	int Untrained;
	int ArmorMalus;
};

struct clsDomainSource
{
	basestring Name;
};

struct clsMonsterTypeSource
{
	basestring Name;
	int GAType;
	int RWRefType;
	int RWWilType;
	int RWZaehType;
	int Mixed;
	int MixedEq;
};

struct clsRegionSource
{
	basestring Name;
};

struct clsSchoolSource
{
	basestring Name;
};

struct clsSizeSource
{
	basestring Name;
	int Mods[3];
	int AC;
	int SizeMod;
};

struct clsSpecialSource
{
	basestring Name;
	int Type;
	int SpellLevel;
	char* Script;
};

struct clsTemplateSource
{
	basestring Name;
	char* CRScript;
	int Mixed;
	basestring ForceType;
	basestring ForbitType;
	char* Script;
	int AttributeMod[6];
	basestring NewType;
	basestring TemplateDesc;
};

struct clsBonusSource
{
	basestring Name;
	int Stack;
};

struct ProfileFeatStruct
{
	int Feat;
};

struct ProfileClassStruct
{
	int Class;
	int Level;
};

struct ProfileWeaponStruct
{
	int Weapon;
};

struct ProfileSkillStruct
{
	int Skill;
	int MinLvl;
	int MaxLvl;
};

struct ProfileSpellStruct
{
	int Spell;
	int MaxNum;
};

struct ProfileEffectStruct
{
	int Effect;
};

struct clsSpecificSource
{
	basestring Name;
	int On;
	int Price;
	char* script;
	p<int> SkillCode;
	int Fight;
	int Mage;
	int Shadow;
	int Divine;
};

struct ProfileStruct
{
	char ProfileName[256];
	
	ProfileClassStruct Classes[32];
	int ClassCount;

	ProfileWeaponStruct Weapons[32];
	int WeaponCount;
	
	ProfileFeatStruct Feats[64];
	int FeatCount;

	ProfileSkillStruct Skills[64];
	int SkillCount;
	
	ProfileSpellStruct Spells[256];
	int SpellCount;

	ProfileEffectStruct Effects[256];
	int EffectCount;

	int Specials[128];
	int SpecialCount;

	int Armor;
	int Shield;
	int ArmorType;
	int ShieldUse[2];

	int AttackType[2];

	int Race;
	int PreferedSchool;

	int AttributePriority[6];

	int MinLevel;
};

struct clsSource
{
	clsCharSource*	CharSource;
	int CharSourceCount;
	clsFeatSource* FeatSource;
	int FeatSourceCount;
	clsEquipSource* EquipSource;
	int EquipSourceCount;
	clsSkillSource* SkillSource;
	int SkillSourceCount;
	clsRaceSource* RaceSource;
	int RaceSourceCount;
	clsSpellSource* SpellSource;
	int SpellSourceCount;
	clsPowerSource* PowerSource;
	int PowerSourceCount;
	clsEffectSource* EffectSource;
	int EffectSourceCount;
	clsSpecificSource* SpecificSource;
	int SpecificSourceCount;
	clsMonsterSource* MonsterSource;
	int MonsterSourceCount;
	int* MonsterCR;

	ProfileStruct* Profiles;
	int ProfileCount;

	clsSchoolSource* SchoolSource;
	int SchoolSourceCount;
	clsSizeSource* SizeSource;
	int SizeSourceCount;
	clsMonsterTypeSource* MonsterTypeSource;
	int MonsterTypeSourceCount;
	clsDomainSource* DomainSource;
	int DomainSourceCount;
	clsTemplateSource* TemplateSource;
	int TemplateSourceCount;
	clsRegionSource* RegionSource;
	int RegionSourceCount;
	clsSpecialSource* SpecialSource;
	int SpecialSourceCount;
	clsBonusSource* BonusSource;
	int BonusSourceCount;

	string AttributeNames[6];

	int StartMoney[100];
	int Treasure[100];

	char* lpSymbolStart;
};

struct clsTempFeatSource
{
	basestring ReqStr;
	basestring SkillStr;
};
struct clsTempCharSource
{
	basestring Derrive;
	basestring SkillStr;
	basestring ReqStr;
	basestring CopySpellList;
	basestring AttachClass;
	basestring ForceWeapon;
	basestring FeatStr;
};
struct clsTempEffectSource
{
	basestring SkillBoost;
};
struct clsTempSkillSource
{
	basestring Synergy;
};
struct clsTempSpecificSource
{
	basestring SkillBoost;
};
struct clsTempRaceSource
{
	basestring SubRace;
};
struct clsTempSource
{
	clsTempCharSource* CharSource;
	clsTempFeatSource* FeatSource;
	clsTempEffectSource* EffectSource;
	clsTempSkillSource* SkillSource;
	clsTempSpecificSource* SpecificSource;
	clsTempRaceSource* RaceSource;

	List<clsMonsterDescSource>* MonsterDesc;

	clsTempSource()
	{
		ZeroMemory(this, sizeof(clsTempSource));
	}
};

extern "C" clsSource Source;

#ifdef INCLUDE_REBUILD
extern "C" clsTempSource TempSource;
#endif
