void ClearChar(clsChar* TargetStruct)
{
	int i, k;
	CharTemplate* TempSave;

	TempSave = TargetStruct->CreationTemplate;
	TargetStruct->~clsChar();
	ZeroMemory(TargetStruct, sizeof(clsChar));
	TargetStruct->CreationTemplate = TempSave;

	for (i = 0;i < MAX_DOMAINS;i++)
	{
		TargetStruct->Domains[i] = -1;
	}
	
	for (k = 0;k < 32;k++)
	{
		for (i = 0;i < 10;i++)
		{
			TargetStruct->SpellsKnownCount[k][i] = -1;
			TargetStruct->SpellsPerDayCount[k][i] = -1;
			TargetStruct->SpellListCount[k][i] = -1;
		}
	}
	TargetStruct->Attacks = 1;
	TargetStruct->AttacksOpportunity = 1;
	TargetStruct->MaxDex = 1024;

	TargetStruct->RingMax = 2;

	TargetStruct->InbornLeft = 1;
	TargetStruct->SubRace = -1;

	DoEffects(NULL, 1);
	DoEffects2(NULL, 0, 1);
}

void CreateCharInit(clsChar* TargetStruct)
{
	int i;

	TargetStruct->CreationTemplate->LastMonster = LastMonster;

	if (ChooseClass == 0 && manual == 0 && manual2 == 0 && readreproduce == 0)
	{
		UseIsaac = true;
		reproduceisaac = 1;
		reproduce = 0;
	}
	else if (readreproduce == 0)
	{
		UseIsaac = false;
	}

	prepos = (unsigned int*) &CTtmp.re.repos;
	retemp = (unsigned int*) &CTtmp.re.retemp[0];
	*prepos = 0;

	readreproducea = readreproduce;
		
	if (UseIsaac)
	{
		if (!IsaacInitDone)
		{
			if (readreproduce)
			{
				isaacrestoreseed(&TargetStruct->CreationTemplate->seed.seed[0]);
			}
			else
			{
				isaacinitrand();
			}
			IsaacInitDone = true;
		}
		isaacsaveseed(&TargetStruct->CreationTemplate->seed.seed[0]);

		IsaacRun = 0;
		readreproducea = readreproduce = 0;
		TargetStruct->CreationTemplate->TemplateType = 49;
	}
	else
	{
		TargetStruct->CreationTemplate->TemplateType = 48;
	}

	prepos = (unsigned int*) &TargetStruct->CreationTemplate->re.repos;
	retemp = (unsigned int*) &TargetStruct->CreationTemplate->re.retemp[0];
	*prepos = 0;

	if (UseIsaac && DebugOutput)
	{
		printf("Charakter Seed:\n");
		for (i = 0;i < 517;i++)
		{
			printf("%2X", TargetStruct->CreationTemplate->seed.seed[i]);
		}
		printf("\n\n");
	}

	CopyMemory(&reheader, TargetStruct->CreationTemplate, sizeof(CharTemplate));
#ifdef AUTO_SAVE
	if (UseIsaac)
	{
		saverep("predefault.rep");
	}
#endif

	ZeroMemory(AgainDep, Source.FeatSourceCount * sizeof(int));
}

void CreateCharExit(clsChar* TargetStruct)
{
	if (TargetStruct->CreationTemplate->Life == -100)
	{
		TPLeft[CurChar] = TargetStruct->Life;
		TargetStruct->CreationTemplate->Life = TargetStruct->Life;
	}
	else
	{
		TPLeft[CurChar] = TargetStruct->CreationTemplate->Life;
	}
		
#ifdef AUTO_SAVE
	saverep("default.rep");
#endif
	readreproducea = 0;
}

void CreateChar(clsChar* TargetStruct, bool child)
{
	int i, typetemp;
	LARGE_INTEGER qwStartTime, qwEndTime;

	QueryPerformanceCounter(&qwStartTime);

	if (child == false)
	{
		CreateCharInit(TargetStruct);
	}

	ClearChar(TargetStruct);

	if (TargetStruct->CreationTemplate->Treasure)
	{
		CreateTreasure(TargetStruct);
		goto CreateCharEnd;
	}

	if (DummyChar == 0 && HenchmenChar == 0)
	{
		FeatNotAgain = (int*) mallocl(Source.FeatSourceCount * sizeof(int), "CreateChar-FeatNotAgain");
		ZeroMemory(FeatNotAgain, Source.FeatSourceCount * sizeof(int));
	}
	
	TargetStruct->Rel = AdvancedRand(Source.RegionSourceCount, &FixedProb, 0, (char*) &Source.RegionSource[0].Name.buffer, sizeof(clsRegionSource), "Region auswhlen!", 0, 1);

	if (DebugOutput) {printf("Starting Character Creation\n");}


	if (TargetStruct->CreationTemplate->Monster == -1)
	{
		TargetStruct->Monster = random(0, 1, "0 Char / 1 Monster", ChooseClass);
	}
	else
	{
		TargetStruct->Monster = TargetStruct->CreationTemplate->Monster;
	}

	manual = manual2;
	if (DebugOutput || manual) {printf("\nHG wird festgelegt\n");}

	TargetStruct->HG = random(TargetStruct->CreationTemplate->MinLevel, TargetStruct->CreationTemplate->MaxLevel, "HG der Kreatur whlen!\n", 0);

	if (TargetStruct->Monster)
	{
RedoMixed:
		if (TargetStruct->HG > 1 &&
			(TargetStruct->CreationTemplate->Mixed || (TargetStruct->CreationTemplate->Monster == -1 && boolrand("Mixed Charakter?", 5, 1, ChooseClass))))
		{
			TargetStruct->Mixed = 1;
			i = random(0, TargetStruct->HG, "Wie viel der HG fr Klasse verwnden?", ChooseClass);
			TargetStruct->HG -= i;
			TargetStruct->MixedHG = i;
		}
		else
		{
			TargetStruct->Mixed = 0;
		}

		if (TargetStruct->CreationTemplate->MonsterName == -1)
		{
			if (DetermineMonster(TargetStruct) == 1)
			{
				if (TargetStruct->Mixed)
				{
					TargetStruct->HG += TargetStruct->MixedHG;
				}
				goto RedoMixed;
			}
		}
		else
		{
			TargetStruct->MonsterName = TargetStruct->CreationTemplate->MonsterName;

			TargetStruct->CRPosCount = 1;
			TargetStruct->CRPosHD[0] = 0;
			TargetStruct->CRPosTemplate[0] = TargetStruct->CreationTemplate->MonsterNameTemplate;
			TargetStruct->CRPosCR[0] = TargetStruct->CreationTemplate->MinLevel;

			SetMonster(TargetStruct);
		}

		DoDomainsSpecial(TargetStruct);
		CalculateSpellCount(TargetStruct);
		CalculateSpells(TargetStruct);
	}
	else
	{
		TargetStruct->Level = TargetStruct->HG + 1;
		if (!(TargetStruct->NPCClass = TargetStruct->CreationTemplate->NPCClass))
		{
			DoTemplateProfile(TargetStruct);
		}

		if (TargetStruct->Profiled)
		{
			typetemp = 1;
		}
		else if (TargetStruct->CreationTemplate->AttributeType == -1)
		{
			typetemp = random(1, 2, "Wrfelmethode whlen: 1 = 3W6, 2 = 4W6\n");
		}
		else
		{
			typetemp = TargetStruct->CreationTemplate->AttributeType;
		}

		if (TargetStruct->CreationTemplate->Monster == -1 && !TargetStruct->Profiled && !TargetStruct->HasTemplate)
		{
			TargetStruct->NPCClass = boolrand("NPC Klassen verwenden?", 20, 1, ChooseClass);
		}

		if (TargetStruct->NPCClass)
		{
			TargetStruct->Level += 1 + TargetStruct->Level / 5;
		}

		if (TargetStruct->CreationTemplate->AttributePreset == 0)
		{
			RandAttributes(TargetStruct, typetemp);
		}
		else
		{
			CopyMemory(TargetStruct->Attributes, TargetStruct->CreationTemplate->AttributePreset, 6 * sizeof(int));
		}

		ChooseRace(TargetStruct);

		DoClasses(TargetStruct, typetemp);

		RaceMod(TargetStruct);
	
		IncreaseAttributes(TargetStruct);
		if (TargetStruct->HasTemplate)
		{
			IncreaseAttributes(TargetStruct, Source.TemplateSource[TargetStruct->HasTemplate].AttributeMod, 6, 1);
		}
		CalcMods(TargetStruct);
		CalcGARW(TargetStruct);

		TargetStruct->WeaponArmorShieldFeats = 1;
		if (Source.CharSource[TargetStruct->Classes[HighestVal(TargetStruct->Levels, TargetStruct->ClassCount)]].NoEq == 2)
		{
			if (random(0, 3, "0 > Get All Required Feats for Weapon/Armor/Shield") == 0)
			{
				TargetStruct->WeaponArmorShieldFeats = 0;
			}
		}

		mCheckChars(PsiCrystal);
		if (mCheckCharsResult)
		{
			TargetStruct->CrystalCount++;
		}

		int tempval = 0;
		DoClassRaceFeats(TargetStruct, &tempval);
		DoLores(TargetStruct);
		DoHierophantAbilities(TargetStruct);

		manual = manual2;
		if (DebugOutput || manual) {printf("\nAngriffsart wird bestimmt\n");}

		DetermineAttackType(TargetStruct);

		manual = manual2;
		if (DebugOutput || manual) {printf("\nAusrstung wird bestimmt\n");}

		if (HenchmenChar == 0 && (
				(DummyChar == 0) ||
				(Source.MonsterTypeSource[dummySource->MonsterType].MixedEq == 1) ||
					(Source.MonsterTypeSource[dummySource->MonsterType].MixedEq > 1 &&
					random(1, Source.MonsterTypeSource[dummySource->MonsterType].MixedEq, "1 = Mit Ausrstung") == 1)
			))
		{
			GenerateEquipment(TargetStruct);
			DoEquipmentEffects(TargetStruct);
		}

		if (HenchmenChar)
		{
			TargetStruct->Treasure = 0;
		}
		else if (DummyChar)
		{
			TargetStruct->Treasure = dummySource->Treasure;
		}
		else
		{
			TargetStruct->Treasure = random(75, 125, "Geldwert in %%") * Source.Treasure[TargetStruct->HG] / 100 * 2;
		}

		InherentBonus(TargetStruct);

		manual = manual2;
		if (DebugOutput || manual) {printf("\nZauber etc werden bestimmt\n");}

		CalcMods(TargetStruct);
		DoDomainsSpecial(TargetStruct);
		CalculateSpellCount(TargetStruct);
		DoArcanas(TargetStruct);
		CalculateSpells(TargetStruct);
		DoPowers(TargetStruct);

		manual = manual2;
		if (DebugOutput || manual) {printf("\nTalente werden festgelegt\n");}

		if (DummyChar)
		{
			for (i = 0;i < dummySource->FeatCount;i++)
			{
				if (Source.FeatSource[dummySource->Feats[i]].MultipleTimes != 2 || !FeatPresent(TargetStruct, dummySource->Feats[i], TargetStruct->FeatCount, dummySource->FeatDependancy[i]))
				{
					AddFeat(TargetStruct, dummySource->Feats[i], NULL, dummySource->FeatDependancy[i]);
				}
			}
		}

		CalculateTypeFeats(TargetStruct);
		CalculateFeats(TargetStruct);
		SetFeatClassSkills(TargetStruct);

		manual = manual2;
		if (DebugOutput) {printf("\nFertigkeiten werden festgelegt\n");}

		CalculateSkills(TargetStruct);
		SetFeatSkillsA(TargetStruct);
		CalcMods(TargetStruct);
		CalcGARW(TargetStruct);

		ReArrangeFeats(TargetStruct);

		DoFeatEffects(TargetStruct);

		CalcMods(TargetStruct);
		DoRaceFeatures(TargetStruct);
		DoClassFeatures(TargetStruct);

		DoEffects4(TargetStruct);
		CalcMods(TargetStruct);
		CalcGARW(TargetStruct);	

		DoCrystal(TargetStruct);
	
		DoHenchmen(TargetStruct);
		
		CalcLife(TargetStruct);

		DoFinalVals(TargetStruct);

		FinishSkills(TargetStruct);

		if (TargetStruct->HasTemplate)
		{
			strcat(TargetStruct->CharText, Source.TemplateSource[TargetStruct->HasTemplate].TemplateDesc);
		}
	}

	ConvertVals2CharText(TargetStruct);
	ExtractSR(TargetStruct);

	if (TargetStruct->Mixed == 1)
	{
		if (loop == 0)
		{
			printf("Creating Mixed Char\n");
		}
		MixChar(TargetStruct);
	}
	
	if (DummyChar == 0 && HenchmenChar == 0)
	{
		freel(FeatNotAgain);
		FeatNotAgain = NULL;
	}

	StripFeats(TargetStruct);
	SummarizeSkills(TargetStruct);

	ReArrangeFeats(TargetStruct);
	ReArrangeSkills(TargetStruct);

	TargetStruct->EquipTreasureStart = TargetStruct->EquipCount;

	if (DummyChar == 0 && HenchmenChar == 0)
	{
		CreateCharTreasure(TargetStruct);
	}

CreateCharEnd:

	if (DummyChar == 0 && HenchmenChar == 0)
	{
		InsertTreasure(TargetStruct);
	}

	DoSellValue(TargetStruct);

	if (child == false)
	{
		CreateCharExit(TargetStruct);
	}

	QueryPerformanceCounter(&qwEndTime);
	TargetStruct->CreationTime = (int) ((qwEndTime.QuadPart - qwStartTime.QuadPart) * 1000000 / qwFreq);
}

#include "clsCharDisplay.h"
